"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DokzBlogProvider = exports.useDokzBlogConfig = void 0;
var react_1 = require("@mdx-js/react");
var omit_1 = __importDefault(require("lodash/fp/omit"));
var react_2 = __importStar(require("react"));
var mdx_1 = __importDefault(require("./components/mdx"));
var WrapperBlog_1 = require("./components/WrapperBlog");
var provider_1 = require("./provider");
var defaultDokzBlogContext = __assign({}, omit_1.default(['docsRootPath', 'sidebarOrdering'], provider_1.defaultDokzContext));
var DokzBlogContext = react_2.createContext(defaultDokzBlogContext);
function useDokzBlogConfig() {
    var ctx = react_2.useContext(DokzBlogContext);
    return ctx;
}
exports.useDokzBlogConfig = useDokzBlogConfig;
var blogMDXComponents = __assign(__assign({}, mdx_1.default), { wrapper: WrapperBlog_1.WrapperBlog });
function DokzBlogProvider(_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    var ctx = __assign(__assign({}, defaultDokzBlogContext), rest);
    var _b = ctx.mdxComponents, userMDXComponents = _b === void 0 ? {} : _b, initialColorMode = ctx.initialColorMode;
    return (react_2.default.createElement(DokzBlogContext.Provider, { value: ctx },
        react_2.default.createElement(react_1.MDXProvider, { components: __assign(__assign({}, blogMDXComponents), userMDXComponents) }, children)));
}
exports.DokzBlogProvider = DokzBlogProvider;
