"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlogPostCard = exports.BlogPosts = void 0;
var react_1 = require("@chakra-ui/react");
var react_2 = require("@chakra-ui/react");
var router_1 = __importDefault(require("next/router"));
var react_3 = __importDefault(require("react"));
var blog_1 = require("../blog");
var icons_1 = require("./icons");
var support_1 = require("./support");
var WrapperBlog_1 = require("./WrapperBlog");
var BG = 'linear-gradient(90deg, rgb(44, 206, 193), rgb(0, 129, 214))';
exports.BlogPosts = function (_a) {
    var _b = _a.heading, heading = _b === void 0 ? 'Blog Posts' : _b, _c = _a.subheading, subheading = _c === void 0 ? 'NEWS, ANNOUNCEMENTS & TIPS' : _c, _d = _a.footer, footer = _d === void 0 ? null : _d;
    var blogRootPath = blog_1.useDokzBlogConfig().blogRootPath;
    if (!blogRootPath) {
        throw new Error('`blogRootPath` is necessary to display the posts list, add it in `DokzBlogProvider` props');
    }
    var tree = support_1.getMdxSidebarTree();
    tree = support_1.findTreeInPath(tree, blogRootPath) || tree;
    var colorMode = react_1.useColorMode().colorMode;
    return (react_3.default.createElement(WrapperBlog_1.BaseWrapperBlog, { overflow: 'hidden', align: 'center' },
        react_3.default.createElement(react_2.Box, { position: 'absolute', bg: { light: 'gray.100', dark: 'rgba(0,0,0,.1)' }[colorMode], top: '-100px', left: '0', right: '0', height: '700px', transform: 'rotate(4deg) skew(4deg)' }),
        react_3.default.createElement(react_2.Stack, { position: 'relative', align: 'center', mt: ['8', null, '24'], mb: ['10', null, '32'], spacing: '10', alignSelf: 'center' },
            react_3.default.createElement(react_2.Box, { as: 'h1', fontWeight: '600', textAlign: 'center', lineHeight: '1.2em', fontSize: '2.4em' }, heading),
            react_3.default.createElement(react_2.Box, { as: 'p', fontWeight: '600', textAlign: 'center', lineHeight: '1.2em', opacity: 0.5 }, subheading)),
        react_3.default.createElement(react_2.Flex, { position: 'relative', justify: 'center', direction: 'row', flexWrap: 'wrap' }, tree.children &&
            tree.children.map(function (node, i) {
                var _a = node.meta, meta = _a === void 0 ? {} : _a;
                return (react_3.default.createElement(exports.BlogPostCard, { url: node.url || '#', m: '8', key: node.url + i, title: node.title || support_1.formatTitle(node.name), date: meta.date, description: meta.description, width: '350px' }));
            })),
        footer));
};
exports.BlogPostCard = function (_a) {
    var title = _a.title, date = _a.date, url = _a.url, description = _a.description, rest = __rest(_a, ["title", "date", "url", "description"]);
    var colorMode = react_1.useColorMode().colorMode;
    return (react_3.default.createElement(react_2.Stack, __assign({ as: 'a', borderRadius: 'md', 
        // borderWidth='1px'
        // @ts-ignore
        href: url, onClick: function (ev) {
            ev.preventDefault();
            router_1.default.push(url);
        }, overflow: 'hidden', h: 'auto', p: '0', align: 'stretch', 
        // minWidth='300px'
        shadow: 'sm', bg: { light: 'white', dark: 'gray.700' }[colorMode] }, rest),
        react_3.default.createElement(react_2.Stack, { w: '100%', spacing: '4', p: '6' },
            react_3.default.createElement(react_2.Box, { fontWeight: 'semibold' }, title),
            react_3.default.createElement(react_2.Box, { fontSize: '0.9em', opacity: 0.7 }, description || '')),
        react_3.default.createElement(react_2.Box, { flex: '1' }),
        react_3.default.createElement(react_2.Stack
        // alignSelf='flex-end'
        , { 
            // alignSelf='flex-end'
            align: 'flex-end', fontSize: '0.9em', opacity: 0.7, w: '100%', px: '6', py: '4', borderTopWidth: { light: '1px', dark: '0px' }[colorMode], bg: { light: 'gray.50', dark: 'gray.800' }[colorMode] },
            react_3.default.createElement(react_2.Stack, { align: 'center', spacing: '2', direction: 'row', opacity: 0.6 },
                react_3.default.createElement(react_2.Box, { boxSize: '0.9em', as: icons_1.DateIcon }),
                react_3.default.createElement(react_2.Box, null, date || 'Unknown publishing date')))));
};
