"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyButton = exports.Code = void 0;
var react_1 = require("@chakra-ui/react");
var prism_react_renderer_1 = __importStar(require("prism-react-renderer"));
var react_2 = __importStar(require("react"));
var fi_1 = require("react-icons/fi");
var provider_1 = require("../provider");
var support_1 = require("./support");
exports.Code = function (_a) {
    var children = _a.children, className = _a.className, _b = _a.hideLinesNumbers, hideLinesNumbers = _b === void 0 ? false : _b, rest = __rest(_a, ["children", "className", "hideLinesNumbers"]);
    // console.log({rest, live})
    var colorMode = react_1.useColorMode().colorMode;
    var prismTheme = provider_1.useDokzConfig().prismTheme;
    var code = typeof children === 'string' ? children.trim() : '';
    var language = className && className.replace(/language-/, '');
    var _c = react_1.useClipboard(code), onCopy = _c.onCopy, hasCopied = _c.hasCopied;
    useOldPlaygroundWarning(rest);
    return (react_2.default.createElement(react_1.Box, { position: 'relative' },
        react_2.default.createElement(prism_react_renderer_1.default, __assign({}, prism_react_renderer_1.defaultProps, { theme: prismTheme[colorMode], code: code, language: language }), function (_a) {
            var className = _a.className, style = _a.style, tokens = _a.tokens, getLineProps = _a.getLineProps, getTokenProps = _a.getTokenProps;
            return (react_2.default.createElement(react_1.Box, { p: '20px', 
                // pt='30px'
                borderRadius: '8px', as: 'pre', fontFamily: support_1.CODE_FONT, fontSize: '0.9em', className: 'dokz codeContainer ' + className, style: __assign({}, style), 
                // boxShadow='0 0 10px 20px rgba(0,0,0,0.01)'
                shadow: 'sm', overflowX: 'auto' },
                react_2.default.createElement(react_1.Box, { className: 'dokz hiddenInPrint', opacity: 0.6, fontSize: '0.9em', position: 'absolute', right: '40px', top: '8px' }, language),
                react_2.default.createElement(exports.CopyButton, { className: 'dokz hiddenInPrint', onClick: onCopy, hasCopied: hasCopied, position: 'absolute', top: '10px', right: '10px' }),
                react_2.default.createElement(react_1.Box, { flexShrink: 0, overflow: 'visible', 
                    // direction='column'
                    // spacing='0'
                    // p='20px'
                    // pt='30px'
                    // borderRadius='8px'
                    as: 'pre', fontFamily: support_1.CODE_FONT, 
                    // fontSize='0.9em'
                    // style={{ ...style }}
                    // overflowX='auto'
                    fontWeight: '500', className: className, style: style }, tokens.map(function (line, i) { return (react_2.default.createElement("div", __assign({ key: i }, getLineProps({ line: line, key: i })),
                    !hideLinesNumbers && (react_2.default.createElement(react_1.Box, { d: 'inline-block', userSelect: 'none', position: 'absolute', left: '0px', textAlign: 'right', minW: '40px', opacity: 0.4, pr: '40px', pl: '20px' }, i + 1)),
                    react_2.default.createElement(react_1.Box, { display: 'inline-block', w: '50px' }),
                    line.map(function (token, key) { return (react_2.default.createElement("span", __assign({ key: key }, getTokenProps({ token: token, key: key })))); }))); }))));
        })));
};
exports.CopyButton = function (_a) {
    var hasCopied = _a.hasCopied, props = __rest(_a, ["hasCopied"]);
    return (react_2.default.createElement(react_1.Box, __assign({ cursor: 'pointer', m: '0', style: {
            strokeWidth: '2px',
        }, opacity: 0.7, boxSize: '1em', as: hasCopied ? fi_1.FiCheck : fi_1.FiCopy }, props)));
};
function useOldPlaygroundWarning(rest) {
    react_2.useEffect(function () {
        if (!!rest.live) {
            console.warn('To use the playground now you must import the explicitly playground component!\nread more at http://localhost:3000/docs/general/preview-react-components');
        }
    }, []);
}
