"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FloatingTableOfContents = void 0;
var react_1 = require("@chakra-ui/react");
var react_2 = __importStar(require("react"));
var pick_1 = __importDefault(require("lodash/pick"));
var parse_github_url_1 = __importDefault(require("parse-github-url"));
var provider_1 = require("../provider");
function FloatingTableOfContents(_a) {
    var table = _a.table, rest = __rest(_a, ["table"]);
    var _b = provider_1.useDokzConfig(), branch = _b.branch, githubUrl = _b.githubUrl;
    var editThisPagePath = useWindowParams().editThisPagePath;
    var editUrl = makeGithubEditUrl({
        branch: branch,
        githubUrl: githubUrl,
        path: editThisPagePath,
    });
    if (!table) {
        return null;
    }
    var Faded = provider_1.useAnimationComponent();
    return (react_2.default.createElement(react_1.Stack, __assign({ spacing: '1em', width: '200px', 
        // minH='1.6em'
        // lineHeight='2.2em'
        // fontWeight='medium'
        // borderLeftWidth='1px'
        as: Faded, cascade: true, pl: '20px' }, rest),
        githubUrl && (react_2.default.createElement(react_1.Box, { as: 'a', display: 'inline-block', 
            // @ts-ignore
            target: '_blank', 
            // @ts-ignore
            href: editUrl },
            react_2.default.createElement(react_1.Button, { fontWeight: '600', variant: 'solid' }, "Edit This Page"))),
        table.children &&
            table.children.map(function (table) {
                return react_2.default.createElement(TableItem, __assign({ key: table.slug }, table));
            })));
}
exports.FloatingTableOfContents = FloatingTableOfContents;
function TableItem(_a) {
    var children = _a.children, depth = _a.depth, title = _a.title, slug = _a.slug, rest = __rest(_a, ["children", "depth", "title", "slug"]);
    var baseW = 20;
    return (react_2.default.createElement(react_1.Stack, __assign({}, rest),
        react_2.default.createElement(react_1.Box, { whiteSpace: 'nowrap', minH: '1.6em' },
            react_2.default.createElement(react_1.Link, { href: slug }, title)),
        react_2.default.createElement(react_1.Stack, { ml: baseW * depth + 'px' }, children &&
            children.map(function (table) {
                return react_2.default.createElement(TableItem, __assign({ key: table.slug }, table));
            }))));
}
function makeGithubEditUrl(_a) {
    var _b = _a.githubUrl, githubUrl = _b === void 0 ? '' : _b, branch = _a.branch, p = _a.path;
    try {
        var parsed = parse_github_url_1.default(githubUrl);
        return "https://github.com/" + (parsed === null || parsed === void 0 ? void 0 : parsed.owner) + "/" + (parsed === null || parsed === void 0 ? void 0 : parsed.name) + "/edit/" + branch + "/" + p;
    }
    catch (_c) {
        return '';
    }
}
function useWindowParams() {
    var _a = react_2.useState({ editThisPagePath: '' }), picked = _a[0], setC = _a[1];
    react_2.useEffect(function () {
        if (typeof window === undefined) {
            return;
        }
        else {
            var keys = ['editThisPagePath'];
            var picked_1 = pick_1.default(window, keys);
            if (Object.keys(picked_1).length === 0) {
                return;
            }
            setC(picked_1);
        }
    }, []);
    return picked;
}
