"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FooterButtons = void 0;
var react_1 = __importDefault(require("react"));
var react_2 = require("@chakra-ui/react");
var react_3 = require("@emotion/react");
react_3.jsx;
var link_1 = __importDefault(require("next/link"));
var support_1 = require("./support");
var router_1 = require("next/router");
var icons_1 = require("./icons");
exports.FooterButtons = function (_a) {
    var rest = __rest(_a, []);
    var router = router_1.useRouter();
    var pathname = (router === null || router === void 0 ? void 0 : router.pathname) || '';
    var tree = support_1.getMdxSidebarTree();
    // console.log('tree', tree)
    // console.log('pathname', pathname)
    var _b = support_1.findSubtreeInPathByUrl(tree, pathname) || {}, next = _b.next, previous = _b.previous;
    // console.log('subtree', next, previous)
    return (react_1.default.createElement(react_2.Stack, __assign({ direction: ['column', null, 'row'], spacing: '6' }, rest),
        (previous === null || previous === void 0 ? void 0 : previous.url) ? (react_1.default.createElement(Button, { title: previous === null || previous === void 0 ? void 0 : previous.title, type: 'previous', href: previous === null || previous === void 0 ? void 0 : previous.url, w: '100%' })) : (react_1.default.createElement(react_2.Box, { flex: '1' })),
        (next === null || next === void 0 ? void 0 : next.url) ? (react_1.default.createElement(Button, { title: next === null || next === void 0 ? void 0 : next.title, type: 'next', href: next === null || next === void 0 ? void 0 : next.url, w: '100%' })) : (react_1.default.createElement(react_2.Box, { flex: '1' }))));
};
var Button = function (_a) {
    var _b = _a.href, href = _b === void 0 ? '' : _b, title = _a.title, type = _a.type, rest = __rest(_a, ["href", "title", "type"]);
    var colorMode = react_2.useColorMode().colorMode;
    var arrow = (react_1.default.createElement(react_2.Box, { transform: type === 'next' ? 'none' : 'scale(-1, 1)', boxSize: '1.2em', as: icons_1.Arrow }));
    return (react_1.default.createElement(link_1.default, { href: href, passHref: true },
        react_1.default.createElement(react_2.Stack, __assign({ align: type === 'next' ? 'flex-end' : 'flex-start', spacing: '2', flex: '1', shadow: 'sm', borderWidth: '1px', borderRadius: 'md', borderColor: { dark: 'gary.700', light: 'gray.200' }[colorMode], px: '6', py: '4', as: 'a', fontWeight: 'medium', 
            // transition='box-shadow 0.3s'
            css: react_3.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n                    :hover {\n                        box-shadow: 0 0 20px rgba(0, 0, 0, 0.1);\n                    }\n                "], ["\n                    :hover {\n                        box-shadow: 0 0 20px rgba(0, 0, 0, 0.1);\n                    }\n                "]))) }, rest),
            react_1.default.createElement(react_2.Stack, { direction: 'row', align: 'center', spacing: '2', opacity: 0.4 },
                type == 'previous' && arrow,
                react_1.default.createElement(react_2.Box, { fontWeight: '600' }, type === 'next' ? 'Next' : 'Previous'),
                type == 'next' && arrow),
            react_1.default.createElement(react_2.Box, { isTruncated: true }, title))));
};
var templateObject_1;
