"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@chakra-ui/react");
var react_2 = __importStar(require("react"));
var md_1 = require("react-icons/md");
var SideNav_1 = require("./SideNav");
var router_1 = require("next/router");
var react_3 = require("@chakra-ui/react");
var useRouteChanged = function (callback) {
    var router = router_1.useRouter();
    react_2.useEffect(function () {
        var handleRouteChange = function (url) {
            callback();
            console.log('App is changing to: ', url);
        };
        router && router.events.on('routeChangeComplete', handleRouteChange);
        return function () {
            router &&
                router.events.off('routeChangeComplete', handleRouteChange);
        };
    }, [router && router.events, callback]);
};
var MobileNav = function (props) {
    var _a = react_1.useDisclosure(), isOpen = _a.isOpen, onToggle = _a.onToggle, onClose = _a.onClose;
    useRouteChanged(onClose);
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(react_1.IconButton, { display: { sm: 'inline-flex', md: 'none' }, "aria-label": 'Navigation Menu', fontSize: '30px', variant: 'ghost', icon: react_2.default.createElement(md_1.MdDehaze, null), onClick: onToggle, marginRight: '-16px' }),
        react_2.default.createElement(react_1.Drawer, { size: 'xs', isOpen: isOpen, placement: 'left', onClose: onClose },
            react_2.default.createElement(react_1.DrawerOverlay, null),
            react_2.default.createElement(react_1.DrawerContent, { height: '100vh', overflowY: 'auto' },
                react_2.default.createElement(react_1.DrawerBody, { pl: '4' },
                    react_2.default.createElement(SideNav_1.SideNav, __assign({ fontSize: '1em' }, props)),
                    react_2.default.createElement(react_3.Box, { h: '100px' }))))));
};
exports.default = MobileNav;
