"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorModeSwitch = exports.GithubLink = void 0;
var react_1 = __importDefault(require("react"));
var react_2 = require("@chakra-ui/react");
var di_1 = require("react-icons/di");
var fi_1 = require("react-icons/fi");
var provider_1 = require("../provider");
var MobileNav_1 = __importDefault(require("./MobileNav"));
exports.GithubLink = function (_a) {
    var _b = _a.url, url = _b === void 0 ? '' : _b, rest = __rest(_a, ["url"]);
    return (react_1.default.createElement(react_2.Box, __assign({ as: 'a', href: url, rel: 'noopener noreferrer', target: '_blank', "aria-label": "Go to Chakra UI's Github Repo", outline: '0', transition: 'all 0.2s', borderRadius: 'md', _focus: {
            boxShadow: 'outline',
        } }, rest),
        react_1.default.createElement(react_2.Box, { as: di_1.DiGithubBadge, boxSize: '8', color: 'current' })));
};
exports.ColorModeSwitch = function (_a) {
    var rest = __rest(_a, []);
    var _b = react_2.useColorMode(), colorMode = _b.colorMode, toggleColorMode = _b.toggleColorMode;
    return (react_1.default.createElement(react_2.IconButton, __assign({ variant: 'ghost', color: 'current', 
        // ml='2'
        fontSize: '20px', "aria-label": "Switch to " + (colorMode === 'light' ? 'dark' : 'light') + " mode", onClick: toggleColorMode, icon: colorMode === 'light' ? react_1.default.createElement(fi_1.FiMoon, null) : react_1.default.createElement(fi_1.FiSun, null) }, rest)));
};
var NavBar = function (_a) {
    var logo = _a.logo, _b = _a.tree, tree = _b === void 0 ? null : _b, navs = _a.items, props = __rest(_a, ["logo", "tree", "items"]);
    var _c = react_2.useColorMode(), colorMode = _c.colorMode, toggleColorMode = _c.toggleColorMode;
    var bg = { light: 'white', dark: 'gray.800' };
    var maxPageWidth = provider_1.useDokzConfig().maxPageWidth;
    return (react_1.default.createElement(react_2.Stack, __assign({ bg: bg[colorMode], zIndex: 4, borderBottomWidth: '1px', borderBottomStyle: 'solid', justifyContent: 'center', alignItems: 'center' }, props),
        react_1.default.createElement(react_2.Stack, { maxWidth: maxPageWidth, as: 'header', width: 'full', 
            // height='60px'
            justify: 'center' },
            react_1.default.createElement(react_2.Flex, { align: 'center', justify: 'space-between' },
                react_1.default.createElement(react_2.Flex, { align: 'center', mr: 5 }, logo),
                react_1.default.createElement(react_2.Flex, { flex: { sm: '1', md: 'none' }, ml: 5, align: 'center', color: 'gray.500', justify: 'flex-end' },
                    Array.isArray(navs) ? (react_1.default.createElement(react_2.Stack, { direction: 'row', spacing: '20px' }, navs.map(function (x, i) { return (react_1.default.createElement(react_2.Stack, { key: i, fontSize: 'text', alignItems: 'center', justify: 'center', fontWeight: 'medium' }, x)); }))) : (navs),
                    tree && react_1.default.createElement(MobileNav_1.default, { tree: tree }))))));
};
exports.default = NavBar;
