"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentLink = exports.TopNavLink = exports.SideNavLink = exports.stringToUrl = void 0;
var react_1 = require("@chakra-ui/react");
var link_1 = __importDefault(require("next/link"));
var router_1 = require("next/router");
var react_2 = __importStar(require("react"));
var NavLink = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    var router = router_1.useRouter();
    var pathname = (router === null || router === void 0 ? void 0 : router.pathname) || '';
    var isActive = false;
    if ((pathname === null || pathname === void 0 ? void 0 : pathname.replace(/\/$/, '').replace(/\bindex$/, '')) ===
        props.href.replace(/\/$/, '')) {
        isActive = true;
    }
    return (react_2.default.createElement(link_1.default, __assign({ passHref: true }, props), typeof children === 'function' ? children(isActive) : children));
};
exports.stringToUrl = function (str, path) {
    if (path === void 0) { path = '/'; }
    return "" + path + str.toLowerCase().split(' ').join('-');
};
exports.SideNavLink = react_2.forwardRef(function (_a, ref) {
    var children = _a.children, icon = _a.icon, props = __rest(_a, ["children", "icon"]);
    var colorMode = react_1.useColorMode().colorMode;
    var color = { light: 'gray.700', dark: 'whiteAlpha.700' };
    return (react_2.default.createElement(react_1.Box, __assign({ ref: ref, as: 'a', mx: -2, display: 'flex', cursor: 'pointer', alignItems: 'center', px: '2', py: '1', transition: 'all 0.2s', 
        // fontWeight='medium'
        outline: 'none', _focus: { shadow: 'outline' }, 
        // color={color[colorMode]}
        _notFirst: { mt: 1 } }, props),
        icon && react_2.cloneElement(icon, { mr: 3 }),
        react_2.default.createElement(react_1.Box, null, children)));
});
exports.TopNavLink = react_2.forwardRef(function (_a, ref) {
    var href = _a.href, props = __rest(_a, ["href"]);
    return (react_2.default.createElement(NavLink, { href: href }, function (isActive) { return (react_2.default.createElement(exports.SideNavLink, __assign({ ref: ref, "aria-current": isActive ? 'page' : undefined }, (isActive && {
        color: 'gray.500',
        fontWeight: 'semibold',
    }), props))); }));
});
exports.ComponentLink = react_2.forwardRef(function (_a, ref) {
    var href = _a.href, props = __rest(_a, ["href"]);
    var colorMode = react_1.useColorMode().colorMode;
    var hoverColor = { light: 'gray.900', dark: 'whiteAlpha.900' };
    var activeColor = { light: 'gray.800', dark: 'gray.200' };
    var activeBg = { light: 'gray.100', dark: 'gray.700' };
    return (react_2.default.createElement(NavLink, { href: href }, function (isActive) { return (react_2.default.createElement(exports.SideNavLink, __assign({ ref: ref, href: href, "aria-current": isActive ? 'page' : undefined, _hover: {
            color: hoverColor[colorMode],
            transform: 'translateX(4px)',
        } }, (isActive && {
        bg: activeBg[colorMode],
        rounded: 'sm',
        color: activeColor[colorMode],
        _hover: {},
    }), props))); }));
});
