"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableOfContents = void 0;
var react_1 = require("@chakra-ui/react");
var Link_1 = require("./Link");
var react_2 = __importStar(require("react"));
var provider_1 = require("../provider");
function TableOfContents(_a) {
    var _b;
    var rest = __rest(_a, []);
    var tableOfContents = react_2.useContext(provider_1.TableOfContentsContext).tableOfContents;
    if (!tableOfContents) {
        return null;
    }
    var Faded = provider_1.useAnimationComponent();
    return (react_2.default.createElement(react_1.Stack, __assign({ my: '10px', spacing: '0.6em', as: Faded, cascade: true }, rest), (_b = tableOfContents === null || tableOfContents === void 0 ? void 0 : tableOfContents.children) === null || _b === void 0 ? void 0 : _b.map(function (table) {
        return react_2.default.createElement(TableItem, __assign({ key: table.slug }, table));
    })));
}
exports.TableOfContents = TableOfContents;
function TableItem(_a) {
    var children = _a.children, depth = _a.depth, title = _a.title, slug = _a.slug, rest = __rest(_a, ["children", "depth", "title", "slug"]);
    var baseW = 20;
    return (react_2.default.createElement(react_1.Stack, __assign({}, rest),
        react_2.default.createElement(react_1.Box, { isTruncated: true, minH: '1.6em' },
            react_2.default.createElement(Link_1.Link, { href: slug }, title)),
        react_2.default.createElement(react_1.Stack, { ml: baseW * depth + 'px' }, children &&
            children.map(function (table) {
                return react_2.default.createElement(TableItem, __assign({ key: table.slug }, table));
            }))));
}
