"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropagatedThemeProvider = exports.Wrapper = void 0;
var react_1 = __importDefault(require("react"));
var react_2 = require("@chakra-ui/react");
var react_3 = require("@chakra-ui/react");
var merge_1 = __importDefault(require("lodash/fp/merge"));
var provider_1 = require("../provider");
var NavBar_1 = __importDefault(require("./NavBar"));
var head_1 = __importDefault(require("next/head"));
var SideNav_1 = require("./SideNav");
var react_4 = require("@emotion/react");
var FloatingTableOfContents_1 = require("./FloatingTableOfContents");
var react_5 = require("react");
var support_1 = require("./support");
var FooterButtons_1 = require("./FooterButtons");
var router_1 = require("next/router");
var SIDENAV_W = 280;
var TABLE_OF_C_W = 200;
var NAVBAR_H = 62;
function Wrapper(props) {
    var _a = props.meta || {}, tableOfContents = _a.tableOfContents, name = _a.name, rest = __rest(_a, ["tableOfContents", "name"]);
    var _b = provider_1.useDokzConfig(), footer = _b.footer, headerLogo = _b.headerLogo, headerItems = _b.headerItems, maxPageWidth = _b.maxPageWidth, bodyColor = _b.bodyColor, fontSize = _b.fontSize, fontWeight = _b.fontWeight, fontFamily = _b.fontFamily, _c = _b.headTitlePrefix, headTitlePrefix = _c === void 0 ? '' : _c;
    var index = support_1.getMdxSidebarTree();
    var router = router_1.useRouter();
    var colorMode = react_2.useColorMode().colorMode;
    var Faded = provider_1.useAnimationComponent();
    return (react_1.default.createElement(PropagatedThemeProvider, { theme: react_2.theme },
        react_1.default.createElement(head_1.default, null, name && (react_1.default.createElement("title", null,
            headTitlePrefix,
            name))),
        react_1.default.createElement(provider_1.TableOfContentsContext.Provider, { value: { tableOfContents: tableOfContents } },
            react_1.default.createElement(react_4.Global, { styles: support_1.globalStyles }),
            react_1.default.createElement(react_3.Stack, { className: 'dokz visibleInPrint noMarginInPrint', align: 'center', minHeight: '100%', color: bodyColor[colorMode], fontSize: fontSize, fontFamily: fontFamily, fontWeight: fontWeight },
                react_1.default.createElement(react_2.Box, { className: 'dokz visibleInPrint', minHeight: '100%', position: 'relative', w: '100%', maxWidth: maxPageWidth },
                    react_1.default.createElement(NavBar_1.default, { px: '6', className: 'dokz hiddenInPrint', logo: headerLogo, items: headerItems, tree: index, height: NAVBAR_H + 'px', 
                        // maxW={PAGE_MAX_W}
                        position: 'fixed', 
                        // mr='auto'
                        // top={0}
                        left: 0, right: 0 }),
                    react_1.default.createElement(SideNav_1.SideNav, { css: react_4.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n                                -webkit-overflow-scrolling: touch;\n                            "], ["\n                                -webkit-overflow-scrolling: touch;\n                            "]))), pl: '6', className: 'dokz hiddenInPrint', alignSelf: 'flex-start', position: 'fixed', top: NAVBAR_H, bottom: 0, fontSize: '0.9em', 
                        // fontWeight='500'
                        // left={0}
                        tree: index, 
                        // height='100%'
                        width: SIDENAV_W, display: ['none', null, 'block'], overflowY: 'auto', overflowX: 'hidden' }),
                    react_1.default.createElement(react_3.Stack, { direction: 'row', minHeight: '100%', className: 'dokz visibleInPrint noMarginInPrint', align: 'stretch', ml: ['none', null, SIDENAV_W], 
                        // mr={['none', null, TABLE_OF_C_W + 30 + 'px']}
                        mt: [NAVBAR_H + 'px'] },
                        react_1.default.createElement(react_3.Stack, { minHeight: '100vh', className: 'dokz visibleInPrint mainContent', direction: 'column', align: 'stretch', overflowY: 'visible', px: ['10px', null, '20px', '30px'], 
                            // spacing='10px'
                            flex: '1', minW: '0', borderRightWidth: [
                                '0px',
                                null,
                                null,
                                null,
                                '1px',
                            ], borderLeftWidth: ['0px', null, '1px'] },
                            react_1.default.createElement(react_3.Stack, { as: Faded, cascade: true, spacing: '2em', align: 'stretch' },
                                props.children,
                                react_1.default.createElement(FooterButtons_1.FooterButtons, { className: 'dokz hiddenInPrint', mt: '60px !important', mb: '2em !important', width: '100%' }),
                                footer)),
                        react_1.default.createElement(FloatingTableOfContents_1.FloatingTableOfContents, { className: 'dokz hiddenInPrint', fontSize: '0.9em', 
                            // fontWeight='400'
                            position: 'sticky', alignSelf: 'flex-start', top: NAVBAR_H, width: TABLE_OF_C_W + 'px', 
                            // right={0}
                            ml: 'auto', height: 'auto', display: ['none', null, null, null, 'block'], pt: '20px', overflowX: 'visible', opacity: 0.8, table: tableOfContents })))))));
}
exports.Wrapper = Wrapper;
function PropagatedThemeProvider(_a) {
    var theme = _a.theme, children = _a.children;
    var existingTheme = react_2.useTheme();
    // console.log({ existingTheme: existingTheme.sizes })
    var merged = react_5.useMemo(function () {
        return merge_1.default(existingTheme, theme);
    }, [theme, existingTheme]);
    return react_1.default.createElement(react_2.ThemeProvider, { theme: merged }, children);
}
exports.PropagatedThemeProvider = PropagatedThemeProvider;
var templateObject_1;
