"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseWrapperBlog = exports.WrapperBlog = void 0;
var react_1 = __importDefault(require("react"));
var react_2 = require("@chakra-ui/react");
var react_3 = require("@emotion/react");
var react_4 = require("@chakra-ui/react");
var blog_1 = require("../blog");
var NavBar_1 = __importDefault(require("./NavBar"));
var support_1 = require("./support");
var Wrapper_1 = require("./Wrapper");
var icons_1 = require("./icons");
var provider_1 = require("../provider");
var head_1 = __importDefault(require("next/head"));
function WrapperBlog(props) {
    var _a = props.meta || {}, _b = _a.name, title = _b === void 0 ? 'Add a `name` to the document frontmatter' : _b, _c = _a.date, date = _c === void 0 ? 'Add a `date` to the document frontmatter' : _c;
    var _d = blog_1.useDokzBlogConfig(), footer = _d.footer, headTitlePrefix = _d.headTitlePrefix;
    return (react_1.default.createElement(exports.BaseWrapperBlog, __assign({}, props),
        react_1.default.createElement(head_1.default, null, title && (react_1.default.createElement("title", null,
            headTitlePrefix,
            title))),
        react_1.default.createElement(react_2.Box, { height: ['40px', null, '40px'] }),
        react_1.default.createElement(react_4.Stack, { spacing: '2em', direction: 'column', width: '100%', maxW: '800px', align: 'stretch' },
            react_1.default.createElement(react_4.Stack, { spacing: '6', align: 'center' },
                react_1.default.createElement(react_2.Box, { as: 'h1', fontWeight: '600', textAlign: 'center', lineHeight: '1.2em', fontSize: '2.4em' }, title),
                react_1.default.createElement(react_4.Stack, { align: 'center', spacing: '2', direction: 'row', opacity: 0.5 },
                    react_1.default.createElement(react_2.Box, { boxSize: '0.8em', as: icons_1.DateIcon }),
                    react_1.default.createElement(react_2.Box, { fontWeight: '500' }, date))),
            react_1.default.createElement(react_2.Box, { height: ['40px', null, '40px'] }),
            props.children,
            footer,
            react_1.default.createElement(react_2.Box, { height: ['40px', null, '40px'] }))));
}
exports.WrapperBlog = WrapperBlog;
exports.BaseWrapperBlog = function (_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    var _b = blog_1.useDokzBlogConfig(), footer = _b.footer, headerLogo = _b.headerLogo, headerItems = _b.headerItems, maxPageWidth = _b.maxPageWidth, bodyColor = _b.bodyColor, fontSize = _b.fontSize, fontFamily = _b.fontFamily, fontWeight = _b.fontWeight;
    var colorMode = react_2.useColorMode().colorMode;
    var tableOfContents = (rest.meta || {}).tableOfContents;
    return (react_1.default.createElement(Wrapper_1.PropagatedThemeProvider, { theme: react_2.theme },
        react_1.default.createElement(provider_1.TableOfContentsContext.Provider, { value: { tableOfContents: tableOfContents } },
            react_1.default.createElement(react_3.Global, { styles: support_1.globalStyles }),
            react_1.default.createElement(react_4.Stack, { className: 'dokz visibleInPrint noMarginInPrint', align: 'center', color: bodyColor[colorMode], fontSize: fontSize, fontFamily: fontFamily, fontWeight: fontWeight },
                react_1.default.createElement(react_4.Flex, __assign({ className: 'dokz visibleInPrint noMarginInPrint mainContent', direction: 'column', align: 'center', overflow: 'auto', width: '100%', maxW: maxPageWidth, px: ['10px', null, '20px', '30px'], 
                    // spacing='10px'
                    flex: '1', minW: '0' }, rest),
                    react_1.default.createElement(NavBar_1.default, { className: 'dokz hiddenInPrint', logo: headerLogo, items: headerItems, bg: 'transparent', width: '100%', 
                        // mr='auto'
                        // top={0}
                        py: '6', px: '0', borderBottomWidth: '0px', left: 0, right: 0 }),
                    children)))));
};
