"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateTableOfContents = void 0;
var mdast_util_toc_1 = __importDefault(require("mdast-util-toc"));
var unist_util_visit_1 = __importDefault(require("unist-util-visit"));
function generateTableOfContents(root) {
    var toc = mdast_util_toc_1.default(root);
    return getItems(toc === null || toc === void 0 ? void 0 : toc.map, { depth: 0 });
}
exports.generateTableOfContents = generateTableOfContents;
function getItems(node, current) {
    if (!node) {
        return {};
    }
    else if (node.type === "paragraph") {
        unist_util_visit_1.default(node, function (item) {
            if (item.type === "link") {
                current.slug = item.url;
            }
            if (item.type === "text") {
                current.title = item.value;
            }
        });
        return current;
    }
    else {
        if (node.type === "list") {
            current.children = node.children.map(function (i) {
                return getItems(i, { depth: current.depth + 1 });
            });
            return current;
        }
        else if (node.type === "listItem") {
            var heading = getItems(node.children[0], {
                depth: current.depth,
            });
            if (node.children.length > 1) {
                getItems(node.children[1], heading);
            }
            return heading;
        }
    }
    return {};
}
