"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getImportsVariables = exports.getFullImports = void 0;
var parser = __importStar(require("@babel/parser"));
var generator = __importStar(require("@babel/generator"));
var traverse_1 = __importDefault(require("@babel/traverse"));
var get_1 = __importDefault(require("lodash/get"));
var fromSpecifiers = function (specifiers) {
    if (specifiers === void 0) { specifiers = []; }
    return Array.isArray(specifiers) && specifiers.length > 0
        ? specifiers.map(function (specifier) { return get_1.default(specifier, 'local.name'); })
        : [];
};
var traverseOnImports = function (fn) { return function (node) {
    try {
        var ast = parser.parse(node.value, { sourceType: 'module' });
        var populated_1 = [];
        traverse_1.default(ast, {
            enter: function (path) {
                if (path.isImportDeclaration()) {
                    populated_1 = populated_1.concat(fn(path));
                    return;
                }
            },
        });
        return populated_1;
    }
    catch (err) {
        return [];
    }
}; };
exports.getFullImports = traverseOnImports(function (path) { return [
    get_1.default(generator.default(path.node), 'code'),
]; });
exports.getImportsVariables = traverseOnImports(function (path) {
    return fromSpecifiers(path.node.specifiers);
});
