"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withMdx = void 0;
var path_1 = __importDefault(require("path"));
exports.withMdx = function (pluginOptions) {
    if (pluginOptions === void 0) { pluginOptions = {}; }
    return function (nextConfig) {
        if (nextConfig === void 0) { nextConfig = {}; }
        var _a = pluginOptions.extension, extension = _a === void 0 ? /\.mdx$/ : _a, _b = pluginOptions.options, mdxOptions = _b === void 0 ? {} : _b;
        return Object.assign({}, nextConfig, {
            webpack: function (config, options) {
                if (!options.defaultLoaders) {
                    throw new Error('This plugin is not compatible with Next.js versions below 5.0.0 https://err.sh/next-plugins/upgrade');
                }
                if (pluginOptions.onStart) {
                    pluginOptions.onStart(config, options);
                }
                config.resolve.alias['nextjs_root_folder_'] = path_1.default.join(process.cwd()); // needed to find the sidebar.json
                config.resolve.alias['buble'] = '@philpl/buble'; // smaller buble version
                config.module = config.module || {};
                config.module.rules = config.module.rules || [];
                config.module.rules.push({
                    test: extension,
                    use: __spreadArrays([
                        options.defaultLoaders.babel
                    ], makeDebugLoader(), [
                        {
                            loader: require.resolve('./injectorLoader'),
                        },
                        {
                            loader: '@mdx-js/loader',
                            options: mdxOptions,
                        },
                    ]),
                });
                if (typeof nextConfig.webpack === 'function') {
                    return nextConfig.webpack(config, options);
                }
                return config;
            },
        });
    };
};
function makeDebugLoader() {
    if (!process.env.DEBUG) {
        return [];
    }
    return [
        {
            loader: require.resolve('./debugLoader'),
        },
    ];
}
