import React, { ReactNode, ComponentType } from 'react';
import { PrismTheme } from 'prism-react-renderer';
import { DokzTableOfContents } from './types';
export declare type DokzProviderProps = {
    children?: any;
    headerLogo?: ReactNode;
    animate?: boolean;
    fontSize?: string | string[];
    fontWeight?: string;
    docsRootPath?: string;
    headTitlePrefix?: string;
    listItemIcon?: React.ComponentType;
    listItemIconEmpty?: React.ComponentType;
    headerItems?: ReactNode[] | ReactNode;
    footer?: ReactNode;
    mdxComponents?: {
        [k: string]: ComponentType<any>;
    };
    prismTheme?: {
        dark: PrismTheme;
        light: PrismTheme;
    };
    maxPageWidth?: string;
    initialColorMode?: 'dark' | 'light';
    bodyColor?: {
        dark: string;
        light: string;
    };
    headingColor?: {
        dark: string;
        light: string;
    };
    sidebarOrdering?: SidebarOrdering;
    fontFamily?: string;
    githubUrl?: string;
    branch?: string;
};
export declare type SidebarOrdering = {
    [k: string]: SidebarOrdering;
} | boolean;
export declare const defaultDokzContext: DokzProviderProps;
export declare function useDokzConfig(): DokzProviderProps;
export declare function useAnimationComponent(): React.FC<import("baby-i-am-faded").FadedProps> | (({ cascade, damping, ...rest }: {
    [x: string]: any;
    cascade: any;
    damping: any;
}) => JSX.Element);
export declare function DokzProvider({ children, ...rest }: DokzProviderProps): JSX.Element;
export declare const TableOfContentsContext: React.Context<{
    tableOfContents: DokzTableOfContents;
}>;
