"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableOfContentsContext = exports.DokzProvider = exports.useAnimationComponent = exports.useDokzConfig = exports.defaultDokzContext = void 0;
var react_1 = require("@mdx-js/react");
var react_2 = __importStar(require("react"));
var mdx_1 = __importDefault(require("./components/mdx"));
var react_3 = require("@chakra-ui/react");
// import lightTheme from 'prism-react-renderer/themes/nightOwlLight'
var oceanicNext_1 = __importDefault(require("prism-react-renderer/themes/oceanicNext"));
var NavBar_1 = require("./components/NavBar");
var icons_1 = require("./components/icons");
var router_1 = require("next/router");
var baby_i_am_faded_1 = require("baby-i-am-faded");
var defaultDarkPrismTheme = __assign(__assign({}, oceanicNext_1.default), { plain: __assign(__assign({}, oceanicNext_1.default.plain), { backgroundColor: '#2D3748' }) });
exports.defaultDokzContext = {
    initialColorMode: 'light',
    headTitlePrefix: '',
    animate: false,
    branch: 'master',
    footer: null,
    headerLogo: (react_2.default.createElement(react_3.Box, { fontWeight: 'medium', fontSize: '32px' }, "Your Logo")),
    listItemIcon: icons_1.Arrow,
    listItemIconEmpty: icons_1.ArrowEmpty,
    headerItems: [react_2.default.createElement(NavBar_1.ColorModeSwitch, { key: 0 })],
    prismTheme: { dark: defaultDarkPrismTheme, light: oceanicNext_1.default },
    maxPageWidth: '1600px',
    bodyColor: { light: '#222', dark: 'rgba(255,255,255,.9)' },
    headingColor: { light: '#111', dark: 'rgba(255,255,255,1)' },
    fontSize: '16px',
    fontFamily: "-apple-system,BlinkMacSystemFont,'Segoe UI',Helvetica,Arial,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\"",
    // fontFamily:
    //     '-apple-system,BlinkMacSystemFont,Segoe UI,Helvetica,Arial,sans-serif,Apple Color Emoji,Segoe UI Emoji',
    fontWeight: '400',
};
var DokzContext = react_2.createContext(exports.defaultDokzContext);
function useDokzConfig() {
    var ctx = react_2.useContext(DokzContext);
    return ctx;
}
exports.useDokzConfig = useDokzConfig;
function useAnimationComponent() {
    var animate = useDokzConfig().animate;
    var isFirstLoad = typeof window === 'undefined' || !window['DOKZ_ROUTE_CHANGED'];
    var C = react_2.useMemo(function () {
        if (!isFirstLoad && animate) {
            baby_i_am_faded_1.Faded.defaultProps = { damping: 0.18 };
            return baby_i_am_faded_1.Faded;
        }
        return function (_a) {
            var cascade = _a.cascade, damping = _a.damping, rest = __rest(_a, ["cascade", "damping"]);
            return react_2.default.createElement("div", __assign({}, rest));
        };
    }, [animate, isFirstLoad]);
    return C;
}
exports.useAnimationComponent = useAnimationComponent;
function DokzProvider(_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    var ctx = __assign(__assign({}, exports.defaultDokzContext), rest);
    var _b = ctx.mdxComponents, userMDXComponents = _b === void 0 ? {} : _b, initialColorMode = ctx.initialColorMode;
    useRouterScroll();
    var router = router_1.useRouter();
    react_2.useEffect(function () {
        var handler = function () {
            if (typeof window !== 'undefined') {
                window['DOKZ_ROUTE_CHANGED'] = true;
            }
        };
        router.events.on('routeChangeStart', handler);
        return function () {
            router.events.off('routeChangeStart', handler);
        };
    }, []);
    return (react_2.default.createElement(DokzContext.Provider, { value: ctx },
        react_2.default.createElement(react_1.MDXProvider, { components: __assign(__assign({}, mdx_1.default), userMDXComponents) }, children)));
}
exports.DokzProvider = DokzProvider;
// table of contents
var defaultTableOfContents = {
    children: [],
    depth: 0,
};
exports.TableOfContentsContext = react_2.createContext({
    tableOfContents: defaultTableOfContents,
});
function useRouterScroll(_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.behavior, behavior = _c === void 0 ? 'smooth' : _c, _d = _b.left, left = _d === void 0 ? 0 : _d, _e = _b.top, top = _e === void 0 ? 0 : _e;
    var router = router_1.useRouter();
    react_2.useEffect(function () {
        // Scroll to given coordinates when router finishes navigating
        // This fixes an inconsistent behaviour between `<Link/>` and `next/router`
        // See https://github.com/vercel/next.js/issues/3249
        var handleRouteChangeComplete = function () {
            if (typeof document !== 'undefined') {
                document.body.scrollTop = document.documentElement.scrollTop = 0;
            }
        };
        router.events.on('routeChangeComplete', handleRouteChangeComplete);
        // If the component is unmounted, unsubscribe from the event
        return function () {
            router.events.off('routeChangeComplete', handleRouteChangeComplete);
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [behavior, left, top]);
}
