var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useColorMode } from '@chakra-ui/react';
import { Box, Flex, Stack } from '@chakra-ui/react';
import Router from 'next/router';
import React from 'react';
import { useDokzBlogConfig } from '../blog';
import { DateIcon } from './icons';
import { findTreeInPath, formatTitle, getMdxSidebarTree } from './support';
import { BaseWrapperBlog } from './WrapperBlog';
var BG = 'linear-gradient(90deg, rgb(44, 206, 193), rgb(0, 129, 214))';
export var BlogPosts = function (_a) {
    var _b = _a.heading, heading = _b === void 0 ? 'Blog Posts' : _b, _c = _a.subheading, subheading = _c === void 0 ? 'NEWS, ANNOUNCEMENTS & TIPS' : _c, _d = _a.footer, footer = _d === void 0 ? null : _d;
    var blogRootPath = useDokzBlogConfig().blogRootPath;
    if (!blogRootPath) {
        throw new Error('`blogRootPath` is necessary to display the posts list, add it in `DokzBlogProvider` props');
    }
    var tree = getMdxSidebarTree();
    tree = findTreeInPath(tree, blogRootPath) || tree;
    var colorMode = useColorMode().colorMode;
    return (React.createElement(BaseWrapperBlog, { overflow: 'hidden', align: 'center' },
        React.createElement(Box, { position: 'absolute', bg: { light: 'gray.100', dark: 'rgba(0,0,0,.1)' }[colorMode], top: '-100px', left: '0', right: '0', height: '700px', transform: 'rotate(4deg) skew(4deg)' }),
        React.createElement(Stack, { position: 'relative', align: 'center', mt: ['8', null, '24'], mb: ['10', null, '32'], spacing: '10', alignSelf: 'center' },
            React.createElement(Box, { as: 'h1', fontWeight: '600', textAlign: 'center', lineHeight: '1.2em', fontSize: '2.4em' }, heading),
            React.createElement(Box, { as: 'p', fontWeight: '600', textAlign: 'center', lineHeight: '1.2em', opacity: 0.5 }, subheading)),
        React.createElement(Flex, { position: 'relative', justify: 'center', direction: 'row', flexWrap: 'wrap' }, tree.children &&
            tree.children.map(function (node, i) {
                var _a = node.meta, meta = _a === void 0 ? {} : _a;
                return (React.createElement(BlogPostCard, { url: node.url || '#', m: '8', key: node.url + i, title: node.title || formatTitle(node.name), date: meta.date, description: meta.description, width: '350px' }));
            })),
        footer));
};
export var BlogPostCard = function (_a) {
    var title = _a.title, date = _a.date, url = _a.url, description = _a.description, rest = __rest(_a, ["title", "date", "url", "description"]);
    var colorMode = useColorMode().colorMode;
    return (React.createElement(Stack, __assign({ as: 'a', borderRadius: 'md', 
        // borderWidth='1px'
        // @ts-ignore
        href: url, onClick: function (ev) {
            ev.preventDefault();
            Router.push(url);
        }, overflow: 'hidden', h: 'auto', p: '0', align: 'stretch', 
        // minWidth='300px'
        shadow: 'sm', bg: { light: 'white', dark: 'gray.700' }[colorMode] }, rest),
        React.createElement(Stack, { w: '100%', spacing: '4', p: '6' },
            React.createElement(Box, { fontWeight: 'semibold' }, title),
            React.createElement(Box, { fontSize: '0.9em', opacity: 0.7 }, description || '')),
        React.createElement(Box, { flex: '1' }),
        React.createElement(Stack
        // alignSelf='flex-end'
        , { 
            // alignSelf='flex-end'
            align: 'flex-end', fontSize: '0.9em', opacity: 0.7, w: '100%', px: '6', py: '4', borderTopWidth: { light: '1px', dark: '0px' }[colorMode], bg: { light: 'gray.50', dark: 'gray.800' }[colorMode] },
            React.createElement(Stack, { align: 'center', spacing: '2', direction: 'row', opacity: 0.6 },
                React.createElement(Box, { boxSize: '0.9em', as: DateIcon }),
                React.createElement(Box, null, date || 'Unknown publishing date')))));
};
