var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { Stack, Box, Link, Button } from '@chakra-ui/react';
import React, { useState, useEffect } from 'react';
import pick from 'lodash/pick';
import parseGithubUrl from 'parse-github-url';
import { useAnimationComponent, useDokzConfig } from '../provider';
export function FloatingTableOfContents(_a) {
    var table = _a.table, rest = __rest(_a, ["table"]);
    var _b = useDokzConfig(), branch = _b.branch, githubUrl = _b.githubUrl;
    var editThisPagePath = useWindowParams().editThisPagePath;
    var editUrl = makeGithubEditUrl({
        branch: branch,
        githubUrl: githubUrl,
        path: editThisPagePath,
    });
    if (!table) {
        return null;
    }
    var Faded = useAnimationComponent();
    return (React.createElement(Stack, __assign({ spacing: '1em', width: '200px', 
        // minH='1.6em'
        // lineHeight='2.2em'
        // fontWeight='medium'
        // borderLeftWidth='1px'
        as: Faded, cascade: true, pl: '20px' }, rest),
        githubUrl && (React.createElement(Box, { as: 'a', display: 'inline-block', 
            // @ts-ignore
            target: '_blank', 
            // @ts-ignore
            href: editUrl },
            React.createElement(Button, { fontWeight: '600', variant: 'solid' }, "Edit This Page"))),
        table.children &&
            table.children.map(function (table) {
                return React.createElement(TableItem, __assign({ key: table.slug }, table));
            })));
}
function TableItem(_a) {
    var children = _a.children, depth = _a.depth, title = _a.title, slug = _a.slug, rest = __rest(_a, ["children", "depth", "title", "slug"]);
    var baseW = 20;
    return (React.createElement(Stack, __assign({}, rest),
        React.createElement(Box, { whiteSpace: 'nowrap', minH: '1.6em' },
            React.createElement(Link, { href: slug }, title)),
        React.createElement(Stack, { ml: baseW * depth + 'px' }, children &&
            children.map(function (table) {
                return React.createElement(TableItem, __assign({ key: table.slug }, table));
            }))));
}
function makeGithubEditUrl(_a) {
    var _b = _a.githubUrl, githubUrl = _b === void 0 ? '' : _b, branch = _a.branch, p = _a.path;
    try {
        var parsed = parseGithubUrl(githubUrl);
        return "https://github.com/" + (parsed === null || parsed === void 0 ? void 0 : parsed.owner) + "/" + (parsed === null || parsed === void 0 ? void 0 : parsed.name) + "/edit/" + branch + "/" + p;
    }
    catch (_c) {
        return '';
    }
}
function useWindowParams() {
    var _a = useState({ editThisPagePath: '' }), picked = _a[0], setC = _a[1];
    useEffect(function () {
        if (typeof window === undefined) {
            return;
        }
        else {
            var keys = ['editThisPagePath'];
            var picked_1 = pick(window, keys);
            if (Object.keys(picked_1).length === 0) {
                return;
            }
            setC(picked_1);
        }
    }, []);
    return picked;
}
