var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Stack, Box, useColorMode } from '@chakra-ui/react';
import { jsx, css } from '@emotion/react';
jsx;
import NextLink from 'next/link';
import { getMdxSidebarTree, findSubtreeInPathByUrl } from './support';
import { useRouter } from 'next/router';
import { Arrow } from './icons';
export var FooterButtons = function (_a) {
    var rest = __rest(_a, []);
    var router = useRouter();
    var pathname = (router === null || router === void 0 ? void 0 : router.pathname) || '';
    var tree = getMdxSidebarTree();
    // console.log('tree', tree)
    // console.log('pathname', pathname)
    var _b = findSubtreeInPathByUrl(tree, pathname) || {}, next = _b.next, previous = _b.previous;
    // console.log('subtree', next, previous)
    return (React.createElement(Stack, __assign({ direction: ['column', null, 'row'], spacing: '6' }, rest),
        (previous === null || previous === void 0 ? void 0 : previous.url) ? (React.createElement(Button, { title: previous === null || previous === void 0 ? void 0 : previous.title, type: 'previous', href: previous === null || previous === void 0 ? void 0 : previous.url, w: '100%' })) : (React.createElement(Box, { flex: '1' })),
        (next === null || next === void 0 ? void 0 : next.url) ? (React.createElement(Button, { title: next === null || next === void 0 ? void 0 : next.title, type: 'next', href: next === null || next === void 0 ? void 0 : next.url, w: '100%' })) : (React.createElement(Box, { flex: '1' }))));
};
var Button = function (_a) {
    var _b = _a.href, href = _b === void 0 ? '' : _b, title = _a.title, type = _a.type, rest = __rest(_a, ["href", "title", "type"]);
    var colorMode = useColorMode().colorMode;
    var arrow = (React.createElement(Box, { transform: type === 'next' ? 'none' : 'scale(-1, 1)', boxSize: '1.2em', as: Arrow }));
    return (React.createElement(NextLink, { href: href, passHref: true },
        React.createElement(Stack, __assign({ align: type === 'next' ? 'flex-end' : 'flex-start', spacing: '2', flex: '1', shadow: 'sm', borderWidth: '1px', borderRadius: 'md', borderColor: { dark: 'gary.700', light: 'gray.200' }[colorMode], px: '6', py: '4', as: 'a', fontWeight: 'medium', 
            // transition='box-shadow 0.3s'
            css: css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n                    :hover {\n                        box-shadow: 0 0 20px rgba(0, 0, 0, 0.1);\n                    }\n                "], ["\n                    :hover {\n                        box-shadow: 0 0 20px rgba(0, 0, 0, 0.1);\n                    }\n                "]))) }, rest),
            React.createElement(Stack, { direction: 'row', align: 'center', spacing: '2', opacity: 0.4 },
                type == 'previous' && arrow,
                React.createElement(Box, { fontWeight: '600' }, type === 'next' ? 'Next' : 'Previous'),
                type == 'next' && arrow),
            React.createElement(Box, { isTruncated: true }, title))));
};
var templateObject_1;
