var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Drawer, DrawerBody, IconButton, useDisclosure, DrawerOverlay, DrawerContent, } from '@chakra-ui/react';
import React, { useEffect } from 'react';
import { MdDehaze } from 'react-icons/md';
import { SideNav } from './SideNav';
import { useRouter } from 'next/router';
import { Box } from '@chakra-ui/react';
var useRouteChanged = function (callback) {
    var router = useRouter();
    useEffect(function () {
        var handleRouteChange = function (url) {
            callback();
            console.log('App is changing to: ', url);
        };
        router && router.events.on('routeChangeComplete', handleRouteChange);
        return function () {
            router &&
                router.events.off('routeChangeComplete', handleRouteChange);
        };
    }, [router && router.events, callback]);
};
var MobileNav = function (props) {
    var _a = useDisclosure(), isOpen = _a.isOpen, onToggle = _a.onToggle, onClose = _a.onClose;
    useRouteChanged(onClose);
    return (React.createElement(React.Fragment, null,
        React.createElement(IconButton, { display: { sm: 'inline-flex', md: 'none' }, "aria-label": 'Navigation Menu', fontSize: '30px', variant: 'ghost', icon: React.createElement(MdDehaze, null), onClick: onToggle, marginRight: '-16px' }),
        React.createElement(Drawer, { size: 'xs', isOpen: isOpen, placement: 'left', onClose: onClose },
            React.createElement(DrawerOverlay, null),
            React.createElement(DrawerContent, { height: '100vh', overflowY: 'auto' },
                React.createElement(DrawerBody, { pl: '4' },
                    React.createElement(SideNav, __assign({ fontSize: '1em' }, props)),
                    React.createElement(Box, { h: '100px' }))))));
};
export default MobileNav;
