var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Box, Flex, IconButton, Stack, useColorMode } from '@chakra-ui/react';
import { DiGithubBadge } from 'react-icons/di';
import { FiMoon, FiSun } from 'react-icons/fi';
import { useDokzConfig } from '../provider';
import MobileNav from './MobileNav';
export var GithubLink = function (_a) {
    var _b = _a.url, url = _b === void 0 ? '' : _b, rest = __rest(_a, ["url"]);
    return (React.createElement(Box, __assign({ as: 'a', href: url, rel: 'noopener noreferrer', target: '_blank', "aria-label": "Go to Chakra UI's Github Repo", outline: '0', transition: 'all 0.2s', borderRadius: 'md', _focus: {
            boxShadow: 'outline',
        } }, rest),
        React.createElement(Box, { as: DiGithubBadge, boxSize: '8', color: 'current' })));
};
export var ColorModeSwitch = function (_a) {
    var rest = __rest(_a, []);
    var _b = useColorMode(), colorMode = _b.colorMode, toggleColorMode = _b.toggleColorMode;
    return (React.createElement(IconButton, __assign({ variant: 'ghost', color: 'current', 
        // ml='2'
        fontSize: '20px', "aria-label": "Switch to " + (colorMode === 'light' ? 'dark' : 'light') + " mode", onClick: toggleColorMode, icon: colorMode === 'light' ? React.createElement(FiMoon, null) : React.createElement(FiSun, null) }, rest)));
};
var NavBar = function (_a) {
    var logo = _a.logo, _b = _a.tree, tree = _b === void 0 ? null : _b, navs = _a.items, props = __rest(_a, ["logo", "tree", "items"]);
    var _c = useColorMode(), colorMode = _c.colorMode, toggleColorMode = _c.toggleColorMode;
    var bg = { light: 'white', dark: 'gray.800' };
    var maxPageWidth = useDokzConfig().maxPageWidth;
    return (React.createElement(Stack, __assign({ bg: bg[colorMode], zIndex: 4, borderBottomWidth: '1px', borderBottomStyle: 'solid', justifyContent: 'center', alignItems: 'center' }, props),
        React.createElement(Stack, { maxWidth: maxPageWidth, as: 'header', width: 'full', 
            // height='60px'
            justify: 'center' },
            React.createElement(Flex, { align: 'center', justify: 'space-between' },
                React.createElement(Flex, { align: 'center', mr: 5 }, logo),
                React.createElement(Flex, { flex: { sm: '1', md: 'none' }, ml: 5, align: 'center', color: 'gray.500', justify: 'flex-end' },
                    Array.isArray(navs) ? (React.createElement(Stack, { direction: 'row', spacing: '20px' }, navs.map(function (x, i) { return (React.createElement(Stack, { key: i, fontSize: 'text', alignItems: 'center', justify: 'center', fontWeight: 'medium' }, x)); }))) : (navs),
                    tree && React.createElement(MobileNav, { tree: tree }))))));
};
export default NavBar;
