var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { Box, useColorMode } from '@chakra-ui/react';
import NextLink from 'next/link';
import { useRouter } from 'next/router';
import React, { cloneElement, forwardRef } from 'react';
var NavLink = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    var router = useRouter();
    var pathname = (router === null || router === void 0 ? void 0 : router.pathname) || '';
    var isActive = false;
    if ((pathname === null || pathname === void 0 ? void 0 : pathname.replace(/\/$/, '').replace(/\bindex$/, '')) ===
        props.href.replace(/\/$/, '')) {
        isActive = true;
    }
    return (React.createElement(NextLink, __assign({ passHref: true }, props), typeof children === 'function' ? children(isActive) : children));
};
export var stringToUrl = function (str, path) {
    if (path === void 0) { path = '/'; }
    return "" + path + str.toLowerCase().split(' ').join('-');
};
export var SideNavLink = forwardRef(function (_a, ref) {
    var children = _a.children, icon = _a.icon, props = __rest(_a, ["children", "icon"]);
    var colorMode = useColorMode().colorMode;
    var color = { light: 'gray.700', dark: 'whiteAlpha.700' };
    return (React.createElement(Box, __assign({ ref: ref, as: 'a', mx: -2, display: 'flex', cursor: 'pointer', alignItems: 'center', px: '2', py: '1', transition: 'all 0.2s', 
        // fontWeight='medium'
        outline: 'none', _focus: { shadow: 'outline' }, 
        // color={color[colorMode]}
        _notFirst: { mt: 1 } }, props),
        icon && cloneElement(icon, { mr: 3 }),
        React.createElement(Box, null, children)));
});
export var TopNavLink = forwardRef(function (_a, ref) {
    var href = _a.href, props = __rest(_a, ["href"]);
    return (React.createElement(NavLink, { href: href }, function (isActive) { return (React.createElement(SideNavLink, __assign({ ref: ref, "aria-current": isActive ? 'page' : undefined }, (isActive && {
        color: 'gray.500',
        fontWeight: 'semibold',
    }), props))); }));
});
export var ComponentLink = forwardRef(function (_a, ref) {
    var href = _a.href, props = __rest(_a, ["href"]);
    var colorMode = useColorMode().colorMode;
    var hoverColor = { light: 'gray.900', dark: 'whiteAlpha.900' };
    var activeColor = { light: 'gray.800', dark: 'gray.200' };
    var activeBg = { light: 'gray.100', dark: 'gray.700' };
    return (React.createElement(NavLink, { href: href }, function (isActive) { return (React.createElement(SideNavLink, __assign({ ref: ref, href: href, "aria-current": isActive ? 'page' : undefined, _hover: {
            color: hoverColor[colorMode],
            transform: 'translateX(4px)',
        } }, (isActive && {
        bg: activeBg[colorMode],
        rounded: 'sm',
        color: activeColor[colorMode],
        _hover: {},
    }), props))); }));
});
