var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { Stack, Box } from '@chakra-ui/react';
import { Link } from './Link';
import React, { useContext } from 'react';
import { TableOfContentsContext, useAnimationComponent } from '../provider';
export function TableOfContents(_a) {
    var _b;
    var rest = __rest(_a, []);
    var tableOfContents = useContext(TableOfContentsContext).tableOfContents;
    if (!tableOfContents) {
        return null;
    }
    var Faded = useAnimationComponent();
    return (React.createElement(Stack, __assign({ my: '10px', spacing: '0.6em', as: Faded, cascade: true }, rest), (_b = tableOfContents === null || tableOfContents === void 0 ? void 0 : tableOfContents.children) === null || _b === void 0 ? void 0 : _b.map(function (table) {
        return React.createElement(TableItem, __assign({ key: table.slug }, table));
    })));
}
function TableItem(_a) {
    var children = _a.children, depth = _a.depth, title = _a.title, slug = _a.slug, rest = __rest(_a, ["children", "depth", "title", "slug"]);
    var baseW = 20;
    return (React.createElement(Stack, __assign({}, rest),
        React.createElement(Box, { isTruncated: true, minH: '1.6em' },
            React.createElement(Link, { href: slug }, title)),
        React.createElement(Stack, { ml: baseW * depth + 'px' }, children &&
            children.map(function (table) {
                return React.createElement(TableItem, __assign({ key: table.slug }, table));
            }))));
}
