var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Box, ThemeProvider, useColorMode, useTheme, theme, } from '@chakra-ui/react';
import { Stack } from '@chakra-ui/react';
import merge from 'lodash/fp/merge';
import { useDokzConfig, TableOfContentsContext, useAnimationComponent, } from '../provider';
import NavBar from './NavBar';
import NextHead from 'next/head';
import { SideNav } from './SideNav';
import { Global, css } from '@emotion/react';
import { FloatingTableOfContents } from './FloatingTableOfContents';
import { useMemo } from 'react';
import { globalStyles, getMdxSidebarTree } from './support';
import { FooterButtons } from './FooterButtons';
import { useRouter } from 'next/router';
var SIDENAV_W = 280;
var TABLE_OF_C_W = 200;
var NAVBAR_H = 62;
export function Wrapper(props) {
    var _a = props.meta || {}, tableOfContents = _a.tableOfContents, name = _a.name, rest = __rest(_a, ["tableOfContents", "name"]);
    var _b = useDokzConfig(), footer = _b.footer, headerLogo = _b.headerLogo, headerItems = _b.headerItems, maxPageWidth = _b.maxPageWidth, bodyColor = _b.bodyColor, fontSize = _b.fontSize, fontWeight = _b.fontWeight, fontFamily = _b.fontFamily, _c = _b.headTitlePrefix, headTitlePrefix = _c === void 0 ? '' : _c;
    var index = getMdxSidebarTree();
    var router = useRouter();
    var colorMode = useColorMode().colorMode;
    var Faded = useAnimationComponent();
    return (React.createElement(PropagatedThemeProvider, { theme: theme },
        React.createElement(NextHead, null, name && (React.createElement("title", null,
            headTitlePrefix,
            name))),
        React.createElement(TableOfContentsContext.Provider, { value: { tableOfContents: tableOfContents } },
            React.createElement(Global, { styles: globalStyles }),
            React.createElement(Stack, { className: 'dokz visibleInPrint noMarginInPrint', align: 'center', minHeight: '100%', color: bodyColor[colorMode], fontSize: fontSize, fontFamily: fontFamily, fontWeight: fontWeight },
                React.createElement(Box, { className: 'dokz visibleInPrint', minHeight: '100%', position: 'relative', w: '100%', maxWidth: maxPageWidth },
                    React.createElement(NavBar, { px: '6', className: 'dokz hiddenInPrint', logo: headerLogo, items: headerItems, tree: index, height: NAVBAR_H + 'px', 
                        // maxW={PAGE_MAX_W}
                        position: 'fixed', 
                        // mr='auto'
                        // top={0}
                        left: 0, right: 0 }),
                    React.createElement(SideNav, { css: css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n                                -webkit-overflow-scrolling: touch;\n                            "], ["\n                                -webkit-overflow-scrolling: touch;\n                            "]))), pl: '6', className: 'dokz hiddenInPrint', alignSelf: 'flex-start', position: 'fixed', top: NAVBAR_H, bottom: 0, fontSize: '0.9em', 
                        // fontWeight='500'
                        // left={0}
                        tree: index, 
                        // height='100%'
                        width: SIDENAV_W, display: ['none', null, 'block'], overflowY: 'auto', overflowX: 'hidden' }),
                    React.createElement(Stack, { direction: 'row', minHeight: '100%', className: 'dokz visibleInPrint noMarginInPrint', align: 'stretch', ml: ['none', null, SIDENAV_W], 
                        // mr={['none', null, TABLE_OF_C_W + 30 + 'px']}
                        mt: [NAVBAR_H + 'px'] },
                        React.createElement(Stack, { minHeight: '100vh', className: 'dokz visibleInPrint mainContent', direction: 'column', align: 'stretch', overflowY: 'visible', px: ['10px', null, '20px', '30px'], 
                            // spacing='10px'
                            flex: '1', minW: '0', borderRightWidth: [
                                '0px',
                                null,
                                null,
                                null,
                                '1px',
                            ], borderLeftWidth: ['0px', null, '1px'] },
                            React.createElement(Stack, { as: Faded, cascade: true, spacing: '2em', align: 'stretch' },
                                props.children,
                                React.createElement(FooterButtons, { className: 'dokz hiddenInPrint', mt: '60px !important', mb: '2em !important', width: '100%' }),
                                footer)),
                        React.createElement(FloatingTableOfContents, { className: 'dokz hiddenInPrint', fontSize: '0.9em', 
                            // fontWeight='400'
                            position: 'sticky', alignSelf: 'flex-start', top: NAVBAR_H, width: TABLE_OF_C_W + 'px', 
                            // right={0}
                            ml: 'auto', height: 'auto', display: ['none', null, null, null, 'block'], pt: '20px', overflowX: 'visible', opacity: 0.8, table: tableOfContents })))))));
}
export function PropagatedThemeProvider(_a) {
    var theme = _a.theme, children = _a.children;
    var existingTheme = useTheme();
    // console.log({ existingTheme: existingTheme.sizes })
    var merged = useMemo(function () {
        return merge(existingTheme, theme);
    }, [theme, existingTheme]);
    return React.createElement(ThemeProvider, { theme: merged }, children);
}
var templateObject_1;
