var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Box, theme, useColorMode } from '@chakra-ui/react';
import { Global } from '@emotion/react';
import { Flex, Stack } from '@chakra-ui/react';
import { useDokzBlogConfig } from '../blog';
import NavBar from './NavBar';
import { globalStyles } from './support';
import { PropagatedThemeProvider } from './Wrapper';
import { DateIcon } from './icons';
import { TableOfContentsContext } from '../provider';
import NextHead from 'next/head';
export function WrapperBlog(props) {
    var _a = props.meta || {}, _b = _a.name, title = _b === void 0 ? 'Add a `name` to the document frontmatter' : _b, _c = _a.date, date = _c === void 0 ? 'Add a `date` to the document frontmatter' : _c;
    var _d = useDokzBlogConfig(), footer = _d.footer, headTitlePrefix = _d.headTitlePrefix;
    return (React.createElement(BaseWrapperBlog, __assign({}, props),
        React.createElement(NextHead, null, title && (React.createElement("title", null,
            headTitlePrefix,
            title))),
        React.createElement(Box, { height: ['40px', null, '40px'] }),
        React.createElement(Stack, { spacing: '2em', direction: 'column', width: '100%', maxW: '800px', align: 'stretch' },
            React.createElement(Stack, { spacing: '6', align: 'center' },
                React.createElement(Box, { as: 'h1', fontWeight: '600', textAlign: 'center', lineHeight: '1.2em', fontSize: '2.4em' }, title),
                React.createElement(Stack, { align: 'center', spacing: '2', direction: 'row', opacity: 0.5 },
                    React.createElement(Box, { boxSize: '0.8em', as: DateIcon }),
                    React.createElement(Box, { fontWeight: '500' }, date))),
            React.createElement(Box, { height: ['40px', null, '40px'] }),
            props.children,
            footer,
            React.createElement(Box, { height: ['40px', null, '40px'] }))));
}
export var BaseWrapperBlog = function (_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    var _b = useDokzBlogConfig(), footer = _b.footer, headerLogo = _b.headerLogo, headerItems = _b.headerItems, maxPageWidth = _b.maxPageWidth, bodyColor = _b.bodyColor, fontSize = _b.fontSize, fontFamily = _b.fontFamily, fontWeight = _b.fontWeight;
    var colorMode = useColorMode().colorMode;
    var tableOfContents = (rest.meta || {}).tableOfContents;
    return (React.createElement(PropagatedThemeProvider, { theme: theme },
        React.createElement(TableOfContentsContext.Provider, { value: { tableOfContents: tableOfContents } },
            React.createElement(Global, { styles: globalStyles }),
            React.createElement(Stack, { className: 'dokz visibleInPrint noMarginInPrint', align: 'center', color: bodyColor[colorMode], fontSize: fontSize, fontFamily: fontFamily, fontWeight: fontWeight },
                React.createElement(Flex, __assign({ className: 'dokz visibleInPrint noMarginInPrint mainContent', direction: 'column', align: 'center', overflow: 'auto', width: '100%', maxW: maxPageWidth, px: ['10px', null, '20px', '30px'], 
                    // spacing='10px'
                    flex: '1', minW: '0' }, rest),
                    React.createElement(NavBar, { className: 'dokz hiddenInPrint', logo: headerLogo, items: headerItems, bg: 'transparent', width: '100%', 
                        // mr='auto'
                        // top={0}
                        py: '6', px: '0', borderBottomWidth: '0px', left: 0, right: 0 }),
                    children)))));
};
