var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { Box, Alert, Divider, Heading, Kbd, Link as ChakraLink, useColorMode, } from '@chakra-ui/react';
import { Children, cloneElement, isValidElement } from 'react';
import { useDokzConfig } from '../provider';
import { Code } from './Code';
import { Link } from './Link';
import { CODE_FONT } from './support';
import { Wrapper } from './Wrapper';
var Pre = function (props) { return React.createElement(Box, __assign({ as: 'pre', rounded: 'sm' }, props)); };
var Table = function (props) { return (React.createElement(Box, { overflowX: 'auto' },
    React.createElement(Box, __assign({ as: 'table', textAlign: 'left', my: '2em', width: 'full' }, props)))); };
var THead = function (props) {
    var colorMode = useColorMode().colorMode;
    var bg = { light: 'gray.50', dark: 'whiteAlpha.100' };
    return (React.createElement(Box, __assign({ as: 'th', bg: bg[colorMode], fontWeight: 'semibold', p: 2, fontSize: 'sm' }, props)));
};
var TData = function (props) { return (React.createElement(Box, __assign({ as: 'td', p: 2, borderTopWidth: '1px', borderColor: 'inherit', fontSize: 'sm', whiteSpace: 'normal' }, props))); };
export var DocsHeading = function (props) {
    var headingColor = useDokzConfig().headingColor;
    var colorMode = useColorMode().colorMode;
    return (React.createElement(Heading, __assign({ fontWeight: 'semibold', pt: '0.6em', 
        // color='black'
        color: headingColor[colorMode], 
        // mt='2.2em !important'
        // mb='10px !important'
        css: {
            '&[id]': {
                pointerEvents: 'none',
            },
            '&[id]:before': {
                display: 'block',
                height: ' 6rem',
                marginTop: '-6rem !important',
                visibility: 'hidden',
                content: "\"\"",
            },
            '&[id]:hover a': { opacity: 1 },
        } }, props),
        React.createElement(Box, { pointerEvents: 'auto' },
            props.children,
            props.id && (React.createElement(ChakraLink, { "aria-label": 'anchor', as: 'a', color: 'gray.500', fontWeight: 'normal', outline: 'none', _focus: { opacity: 1, boxShadow: 'outline' }, opacity: 0, ml: '0.375rem', href: "#" + props.id }, "#")))));
};
var MdxText = function (props) {
    var colorMode = useColorMode().colorMode;
    return React.createElement(Box, __assign({ as: 'p', lineHeight: '1.8em' }, props));
};
var MDXComponents = {
    wrapper: Wrapper,
    h1: function (props) { return React.createElement(DocsHeading, __assign({ as: 'h1', fontSize: '2em' }, props)); },
    h2: function (props) { return React.createElement(DocsHeading, __assign({ as: 'h2', fontSize: '1.4em' }, props)); },
    h3: function (props) { return React.createElement(DocsHeading, __assign({ as: 'h3', fontSize: '1.2em' }, props)); },
    // img: (props) => {
    //     return (
    //         <Stack my='20px' direction='column'>
    //             <Image
    //                 borderWidth='1px'
    //                 maxWidth='700px'
    //                 // shadow='md'
    //                 borderRadius='8px'
    //                 {...props}
    //             />
    //         </Stack>
    //     )
    // },
    inlineCode: function (props) {
        var colorMode = useColorMode().colorMode;
        return (React.createElement(Box, __assign({ as: 'code', display: 'inline-block', fontFamily: CODE_FONT, fontSize: '0.9em', px: '0.2em !important', rounded: 'sm', bg: {
                light: 'rgba(228, 235, 242, 0.6)',
                dark: 'rgba(106, 111, 117, 0.6)',
            }[colorMode], 
            // color={{ light: '#264459', dark: 'white' }[colorMode]}
            lineHeight: 'normal' }, props)));
    },
    code: function (props) { return React.createElement(Code, __assign({}, props)); },
    pre: Pre,
    kbd: Kbd,
    // br: (props) => <Box {...props} />,
    hr: function (props) { return React.createElement(Divider, __assign({ my: '3em !important' }, props)); },
    table: Table,
    th: THead,
    td: TData,
    a: Link,
    p: function (props) {
        return React.createElement(MdxText, __assign({ as: 'p' }, props));
    },
    ul: function (_a) {
        var children = _a.children, isOdd = _a.isOdd, props = __rest(_a, ["children", "isOdd"]);
        return (React.createElement(Box, __assign({ mt: '0 !important', className: 'dokz', as: 'ul', pl: '1em' }, props), Children.map(children, function (child) {
            return cloneElement(child, { isOdd: !isOdd });
        })));
    },
    ol: function (_a) {
        var children = _a.children, isOdd = _a.isOdd, props = __rest(_a, ["children", "isOdd"]);
        return (React.createElement(Box, __assign({ mt: '0 !important', className: 'dokz', as: 'ol', pl: '2em' }, props), Children.map(children, function (child, number) {
            return cloneElement(child, {
                isOdd: !isOdd,
                isOrdered: true,
            });
        })));
    },
    li: function (_a) {
        var isOdd = _a.isOdd, isOrdered = _a.isOrdered, children = _a.children, props = __rest(_a, ["isOdd", "isOrdered", "children"]);
        var _b = useDokzConfig(), listItemIcon = _b.listItemIcon, listItemIconEmpty = _b.listItemIconEmpty;
        var listIcon = isOrdered ? (React.createElement(Box, { display: 'inline-block' })) : (React.createElement(Box, { mr: '0.6em', ml: '-1.6em', display: 'inline-block', boxSize: '1.1em', as: isOdd ? listItemIcon : listItemIconEmpty }));
        return (React.createElement(Box, { ml: (!isOrdered ? '1em' : '0') + ' !important', as: 'li', listStyleType: isOrdered ? 'inherit' : 'none', my: '0.8em' },
            listIcon,
            React.createElement(Box, __assign({ as: 'p', display: 'inline' }, props), Children.map(children, function (child) {
                if (isValidElement(child)) {
                    return cloneElement(child, {
                        isOdd: isOdd,
                    });
                }
                return child;
            }))));
    },
    blockquote: function (props) { return (React.createElement(Alert, __assign({ shadow: 'sm', 
        // mt='20px !important'
        variant: 'left-accent', status: 'warning', css: { '> *:first-of-type': { marginTop: 0 } } }, props))); },
};
// const ChakraProvider = ({ children, theme }) => {
//   return (
//     <ThemeProvider theme={theme}>
//       <ColorModeProvider>
//         <CSSReset />
//         {children}
//       </ColorModeProvider>
//     </ThemeProvider>
//   );
// };
export default MDXComponents;
