import makeToc from 'mdast-util-toc';
import visit from 'unist-util-visit';
export function generateTableOfContents(root) {
    var toc = makeToc(root);
    return getItems(toc === null || toc === void 0 ? void 0 : toc.map, { depth: 0 });
}
function getItems(node, current) {
    if (!node) {
        return {};
    }
    else if (node.type === "paragraph") {
        visit(node, function (item) {
            if (item.type === "link") {
                current.slug = item.url;
            }
            if (item.type === "text") {
                current.title = item.value;
            }
        });
        return current;
    }
    else {
        if (node.type === "list") {
            current.children = node.children.map(function (i) {
                return getItems(i, { depth: current.depth + 1 });
            });
            return current;
        }
        else if (node.type === "listItem") {
            var heading = getItems(node.children[0], {
                depth: current.depth,
            });
            if (node.children.length > 1) {
                getItems(node.children[1], heading);
            }
            return heading;
        }
    }
    return {};
}
