var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import to from 'await-to-js';
import dirTree from 'directory-tree';
import getFrontMatter from 'front-matter';
import fs from 'fs';
import path from 'path';
export function getMdxFilesIndex() {
    return __awaiter(this, void 0, void 0, function () {
        var pagesPath, tree, pagesNode;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getPagesPath()
                    // console.log({ searchPath })
                ];
                case 1:
                    pagesPath = _a.sent();
                    tree = dirTree(pagesPath, { normalizePath: true, extensions: /\.mdx?/ }, function (node) {
                        var pathName = node.path;
                        var content = fs.readFileSync(pathName).toString();
                        var _a = getFrontMatter(content).attributes, attributes = _a === void 0 ? {} : _a;
                        // console.log({ frontMatter: frontMatter.attributes })
                        var _b = attributes.name, name = _b === void 0 ? '' : _b, meta = __rest(attributes, ["name"]);
                        node.meta = meta || {};
                        node.title = name || formatTitle(node.name || '');
                        node.url = formatRelativePath(path.relative(pagesPath, pathName));
                        delete node.extension;
                        delete node.size;
                        delete node.type;
                    });
                    // the sidebar handle only the case pages is root
                    if (tree.name === 'src') {
                        pagesNode = tree.children.find(function (x) { return x.name === 'pages'; });
                        return [2 /*return*/, pagesNode];
                    }
                    // console.log({ tree })
                    return [2 /*return*/, tree];
            }
        });
    });
}
function formatRelativePath(path) {
    // console.log(path)
    var relativePath = path
        .replace('.mdx', '')
        .replace('.md', '')
        .replace('.jsx', '')
        .replace('.tsx', '')
        .replace('.js', '')
        .replace(/\bindex$/, '');
    return '/' + (relativePath || '');
}
function formatTitle(name) {
    return capitalizeFirstLetter(name
        .replace(/_/g, ' ')
        .replace(/-/g, ' ')
        .replace(/\.mdx?/, ''));
}
function capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}
function getPagesPath() {
    return __awaiter(this, void 0, void 0, function () {
        var _a, err, stats, _b, err, stats;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, to(fs.promises.stat('src/pages'))];
                case 1:
                    _a = _c.sent(), err = _a[0], stats = _a[1];
                    if (!err && stats.isDirectory()) {
                        return [2 /*return*/, 'src/pages'];
                    }
                    return [4 /*yield*/, to(fs.promises.stat('pages'))];
                case 2:
                    _b = _c.sent(), err = _b[0], stats = _b[1];
                    if (!err && stats.isDirectory()) {
                        return [2 /*return*/, 'pages'];
                    }
                    throw new Error('cannot find pages directory');
            }
        });
    });
}
