var getRepoRoot = require('get-git-config').getRepoRoot;
var path = require('path');
var runtimeClassic = "/** @jsxRuntime classic */\n";
module.exports = function (content) {
    try {
        var callback = this.async();
        // const options = this.getOptions()
        var root = getRepoRoot();
        if (!root) {
            console.log("cannot find the .git directory, edit-this-page feature is disabled");
            callback(null, runtimeClassic + content);
            return;
        }
        var filePath = this.resourcePath;
        var editThisPagePath = path.relative(root, filePath);
        var toInject = {
            editThisPagePath: editThisPagePath,
        };
        // console.log(editThisPagePath)
        var codeToInsert = "\n    \n\n    if (typeof window !== 'undefined') {\n        const toInject = " + JSON.stringify(toInject) + ";\n        for (let k in toInject) {\n            window[k] = toInject[k];\n        }\n    };\n";
        return callback(null, runtimeClassic + content + codeToInsert);
    }
    catch (e) {
        console.error("got an error in edit this page loader: " + e);
        return callback(null, runtimeClassic + content);
    }
};
