var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import flatten from 'lodash/flatten';
import nodeToString from 'hast-util-to-string';
import { formatter } from './utils/format';
import { componentName, sanitizeCode, removeTags } from './utils/jsx';
import { getImportsVariables } from './utils/imports';
import { getExportsVariables } from './utils/exports';
var isPlayground = function (name) {
    return name === 'Playground';
};
var addComponentsProps = function (scopes) { return function (node, idx) {
    var name = componentName(node.value);
    var tagOpen = new RegExp("^\\<" + name);
    var formatted = formatter(nodeToString(node));
    var code = formatted.slice(1, Infinity);
    var scope = "{props, " + scopes.join(',') + "}";
    var child = sanitizeCode(removeTags(code));
    var newTag = "<" + name + " __position={" + idx + "} code={'" + child + "'} scope={" + scope + "}";
    // console.log(newTag)
    node.value = node.value.replace(tagOpen, newTag);
}; };
export var playgroundRegex = /<Playground\b/;
export var injectCodeToPlayground = function () { return function (tree, file) {
    if (file.contents.search(playgroundRegex) == -1) {
        return tree;
    }
    var playgroundComponents = tree.children
        .filter(function (node) { return node.type === 'jsx'; })
        .filter(function (node) {
        var name = componentName(node.value);
        return isPlayground(name);
    });
    var importNodes = tree.children.filter(function (n) { return n.type === 'import'; });
    var exportNodes = tree.children.filter(function (n) { return n.type === 'export'; });
    var importedScopes = flatten(importNodes.map(getImportsVariables));
    var exportedScopes = flatten(exportNodes.map(getExportsVariables)); // TODO exports not working, migrate to es lexer
    // filter added to avoid throwing if an unexpected type is exported
    var scopes = __spreadArrays(importedScopes, exportedScopes).filter(Boolean);
    playgroundComponents.forEach(addComponentsProps(scopes));
    return tree;
}; };
