import * as parser from '@babel/parser';
import traverse from '@babel/traverse';
export var valueFromTraverse = function (condition, predicate) {
    if (predicate === void 0) { predicate = function (p) { return p; }; }
    return function (code) {
        var value = '';
        var ast = parser.parse(code, { plugins: ['jsx'] });
        traverse(ast, {
            enter: function (path) {
                if (condition(path)) {
                    value = predicate(path);
                    path.stop();
                    return;
                }
            },
        });
        return value;
    };
};
export var codeFromNode = function (condition) { return function (code) {
    return valueFromTraverse(condition, function (p) { return code.slice(p.node.start, p.node.end); })(code);
}; };
