import * as parser from '@babel/parser';
import * as generator from '@babel/generator';
import traverse from '@babel/traverse';
import get from 'lodash/get';
var fromSpecifiers = function (specifiers) {
    if (specifiers === void 0) { specifiers = []; }
    return Array.isArray(specifiers) && specifiers.length > 0
        ? specifiers.map(function (specifier) { return get(specifier, 'local.name'); })
        : [];
};
var traverseOnImports = function (fn) { return function (node) {
    try {
        var ast = parser.parse(node.value, { sourceType: 'module' });
        var populated_1 = [];
        traverse(ast, {
            enter: function (path) {
                if (path.isImportDeclaration()) {
                    populated_1 = populated_1.concat(fn(path));
                    return;
                }
            },
        });
        return populated_1;
    }
    catch (err) {
        return [];
    }
}; };
export var getFullImports = traverseOnImports(function (path) { return [
    get(generator.default(path.node), 'code'),
]; });
export var getImportsVariables = traverseOnImports(function (path) {
    return fromSpecifiers(path.node.specifiers);
});
