import * as jsxUtils from 'jsx-ast-utils';
import strip from 'strip-indent';
import escapeJS from 'js-string-escape';
import { valueFromTraverse, codeFromNode } from './ast';
export var propFromElement = function (prop) {
    return valueFromTraverse(function (p) { return p.isJSXOpeningElement(); }, function (p) { return jsxUtils.getPropValue(jsxUtils.getProp(p.node.attributes, prop)); });
};
export var removeTags = function (code) {
    var open = codeFromNode(function (p) { return p.isJSXOpeningElement(); });
    var close = codeFromNode(function (p) { return p.isJSXClosingElement(); });
    return code.replace(open(code), '').replace(close(code), '');
};
export var sanitizeCode = function (code) {
    var trimmed = strip(code).trim();
    var newCode = trimmed.startsWith('{') && trimmed.endsWith('}')
        ? trimmed.substr(1, trimmed.length - 2).trim()
        : trimmed;
    return escapeJS(strip(newCode));
};
var regex = /^\<\\?(\w+)/;
export var componentName = function (value) {
    var match = value.match(regex);
    return match && match[1];
};
