var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { MDXProvider } from '@mdx-js/react';
import React, { createContext, useContext, useEffect, useMemo, } from 'react';
import MDXComponents from './components/mdx';
import { Box, } from '@chakra-ui/react';
// import lightTheme from 'prism-react-renderer/themes/nightOwlLight'
import darkPrismTheme from 'prism-react-renderer/themes/oceanicNext';
import { ColorModeSwitch } from './components/NavBar';
import { Arrow, ArrowEmpty } from './components/icons';
import { useRouter } from 'next/router';
import { Faded } from 'baby-i-am-faded';
var defaultDarkPrismTheme = __assign(__assign({}, darkPrismTheme), { plain: __assign(__assign({}, darkPrismTheme.plain), { backgroundColor: '#2D3748' }) });
export var defaultDokzContext = {
    initialColorMode: 'light',
    headTitlePrefix: '',
    animate: false,
    branch: 'master',
    footer: null,
    headerLogo: (React.createElement(Box, { fontWeight: 'medium', fontSize: '32px' }, "Your Logo")),
    listItemIcon: Arrow,
    listItemIconEmpty: ArrowEmpty,
    headerItems: [React.createElement(ColorModeSwitch, { key: 0 })],
    prismTheme: { dark: defaultDarkPrismTheme, light: darkPrismTheme },
    maxPageWidth: '1600px',
    bodyColor: { light: '#222', dark: 'rgba(255,255,255,.9)' },
    headingColor: { light: '#111', dark: 'rgba(255,255,255,1)' },
    fontSize: '16px',
    fontFamily: "-apple-system,BlinkMacSystemFont,'Segoe UI',Helvetica,Arial,sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\"",
    // fontFamily:
    //     '-apple-system,BlinkMacSystemFont,Segoe UI,Helvetica,Arial,sans-serif,Apple Color Emoji,Segoe UI Emoji',
    fontWeight: '400',
};
var DokzContext = createContext(defaultDokzContext);
export function useDokzConfig() {
    var ctx = useContext(DokzContext);
    return ctx;
}
export function useAnimationComponent() {
    var animate = useDokzConfig().animate;
    var isFirstLoad = typeof window === 'undefined' || !window['DOKZ_ROUTE_CHANGED'];
    var C = useMemo(function () {
        if (!isFirstLoad && animate) {
            Faded.defaultProps = { damping: 0.18 };
            return Faded;
        }
        return function (_a) {
            var cascade = _a.cascade, damping = _a.damping, rest = __rest(_a, ["cascade", "damping"]);
            return React.createElement("div", __assign({}, rest));
        };
    }, [animate, isFirstLoad]);
    return C;
}
export function DokzProvider(_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    var ctx = __assign(__assign({}, defaultDokzContext), rest);
    var _b = ctx.mdxComponents, userMDXComponents = _b === void 0 ? {} : _b, initialColorMode = ctx.initialColorMode;
    useRouterScroll();
    var router = useRouter();
    useEffect(function () {
        var handler = function () {
            if (typeof window !== 'undefined') {
                window['DOKZ_ROUTE_CHANGED'] = true;
            }
        };
        router.events.on('routeChangeStart', handler);
        return function () {
            router.events.off('routeChangeStart', handler);
        };
    }, []);
    return (React.createElement(DokzContext.Provider, { value: ctx },
        React.createElement(MDXProvider, { components: __assign(__assign({}, MDXComponents), userMDXComponents) }, children)));
}
// table of contents
var defaultTableOfContents = {
    children: [],
    depth: 0,
};
export var TableOfContentsContext = createContext({
    tableOfContents: defaultTableOfContents,
});
function useRouterScroll(_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.behavior, behavior = _c === void 0 ? 'smooth' : _c, _d = _b.left, left = _d === void 0 ? 0 : _d, _e = _b.top, top = _e === void 0 ? 0 : _e;
    var router = useRouter();
    useEffect(function () {
        // Scroll to given coordinates when router finishes navigating
        // This fixes an inconsistent behaviour between `<Link/>` and `next/router`
        // See https://github.com/vercel/next.js/issues/3249
        var handleRouteChangeComplete = function () {
            if (typeof document !== 'undefined') {
                document.body.scrollTop = document.documentElement.scrollTop = 0;
            }
        };
        router.events.on('routeChangeComplete', handleRouteChangeComplete);
        // If the component is unmounted, unsubscribe from the event
        return function () {
            router.events.off('routeChangeComplete', handleRouteChangeComplete);
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [behavior, left, top]);
}
